﻿#targetengine "scriptPrintExportConditionSets";
/*****************************************************************
	Print/Exprot Condition Set's
	Type: Document Script
	Version: 0.1
	(c) Genusatplay (genus+at+play at gmail dot com)
*****************************************************************/
if ( app.documents.length == 0 )
{
	alert("Please open a document and try again.");
	exit();
}
var thisDoc = app.activeDocument;
if ( thisDoc.conditionSets.length == 0 )
{
	alert("The document does not contain Condition Sets");
	exit();
}

var selectListArr = thisDoc.conditionSets;
var itemsForPrint = [];

var w = new Window("dialog","Print/Export Condition Sets");
var selectList = w.add("listbox",undefined, selectListArr.everyItem().name, {multiselect: true});
selectList.maximumSize.height = 365;
selectList.minimumSize.width = 150;
for (var i = 0; i < selectList.items.length; i++)
	selectList.items[i].checked = false;
selectList.onChange = ListCheck;

var selectAll = w.add("checkbox",undefined,"Select all Set's");

var exportPresetGroup = w.add("group");
exportPresetGroup.add("statictext", undefined, "PDF Export Preset:");
var pdfExportPresetList = exportPresetGroup.add("dropdownlist", undefined, app.pdfExportPresets.everyItem().name);
//pdfExportPresetList.items[0].selected = true;

var printOrExportGroup = w.add("group");
var actionPrint = printOrExportGroup.add("radiobutton",undefined,"Print");
var actionPDF = printOrExportGroup.add("radiobutton",undefined,"Export");
actionPrint.value = true;

var buttonGroup = w.add ("group");
buttonGroup.alignment = "right";
buttonGroup.add ("button", undefined, "OK");
buttonGroup.add ("button", undefined, "Cancel");

if ( w.show () == 1)
{
	if ( selectAll.value )
	{
		PrintExportConditionSets(selectListArr);
	}
	else if ( HaveSelection() )
	{
		for (var i = 0; i < selectList.items.length; i++)
			if ( selectList.items[i].checked )
				itemsForPrint.push(selectListArr[i]);
		PrintExportConditionSets(itemsForPrint);
	}
}
else
	exit ();

function PrintExportConditionSets( arrayOfSets )
{
	if ( actionPrint.value )
	{		
		var showDialog = true;
		if ( arrayOfSets.length != 0 )
		{
			for (var i = 0; i < arrayOfSets.length; i++)
			{
				thisDoc.conditionalTextPreferences.activeConditionSet = arrayOfSets[i];
				thisDoc.print(showDialog);
				showDialog = false;
			}        
		}
	}
	else 
	{
		if ( pdfExportPresetList.selection != null )
		{
			var getFolder = Folder.selectDialog("Choose a Folder");
			$.writeln(getFolder); //del
			if ( arrayOfSets.length != 0 )
			{
				for (var i = 0; i < arrayOfSets.length; i++)
				{
					thisDoc.conditionalTextPreferences.activeConditionSet = arrayOfSets[i];
					var myRegExp = new RegExp(":","gi");
					var fileRegExp = /[\\\/:\*\?\"\<\>\|]/ig;
					var fileName = arrayOfSets[i].name;
					fileName = fileName.replace( fileRegExp, "_");
					var filePath = getFolder + "/" + fileName + ".pdf";
					var pdfFile = new File(filePath);
					var currExprotPreset = app.pdfExportPresets.item(pdfExportPresetList.selection.index);
					$.writeln(currExprotPreset.name);
					thisDoc.exportFile(ExportFormat.PDF_TYPE, pdfFile, false, currExprotPreset);
				}        
			}
			alert("Export complete.");
		}
		else 
		{
			alert("Select preset for export to PDF.");
			exit();
		}
	}
}

function ListCheck()
{
	if (this.selection != null)
		this.selection.pop().checked = !this.selection.pop().checked;
	this.selection.pop().selected = !this.selection.pop().selected;     
}

function HaveSelection ()
{
	for ( var i = 0; i < selectList.items.length; i++ )
	{
		if ( selectList.items[i].checked == true )
			return  true;
	}
	return false;
}